// ________________________________________
// 01.cpp
// ----------------------------------------

// .... What's new? .......................
// "write" writes a big_number to screen
// "get_number" gets a big_number from the keyboard
// "put_to_zero" assigns the value 0 to a big_number
// ........................................

#include <stdio.h>
#include <iostream.h>

// To run with the Microsoft Visual C++ Compiler, just replace
// the two #include statements with the following one:
// #include <iostream>

#define numbertype unsigned short int // Adapt to the number of positions
#define basis 10                      // Adapt to the numberin system
                                      // (decimal, hex, etc...)
#define small unsigned short int      // small must be great enough to
                                      // contain the basis
#define sufficient 200                // chane length for input

const numbertype positions = 7;


numbertype a_function ();
numbertype a_function ()
{
   std::cout  <<  "Just a_function...\n";
   return (9);
}


class big_number
      // ----------------------------------
      // Definition of class big_number
      // ----------------------------------
{
    small cipher [positions+1];
    numbertype  maxpos;
    bool positive;
  public:
    void write ();
    void put_to_zero ();
    void get_number ();
};


void big_number::write ()
      // ----------------------------------
      // Public accessor function
      // writes the big_number to screen
      // ----------------------------------
{
    numbertype poscounter;
    if (positive == true) std::cout <<  "+"; else std::cout << "-";
    for (poscounter = positions; poscounter > 0; poscounter--)
      std::cout  << cipher [poscounter];
      std::cout  << cipher [0];  // write the last one

    std::cout <<  "   ";            // Control to be eliminated later
    std::cout << maxpos << "\n\n";  // -------

    std::cout << "\n";
}


void big_number::put_to_zero ()
      // ----------------------------------
      // Public accessor function
      // puts the big_number to 0
      // ----------------------------------
{
    numbertype poscounter;

    for (poscounter = positions; poscounter > 0; poscounter--)
      cipher [poscounter] = 0;
      cipher [poscounter] = 0;  // the last one (position 0)
    maxpos = 0;
    positive = true;
}


void big_number::get_number ()
      // ----------------------------------
      // Number input from keyboard
      // ----------------------------------
{
   char s [sufficient];
   bool ok;
   bool final_reached;
   bool zero;              // the chain represents 0
   numbertype i, j, max;
   numbertype length;

   ok = false;

   while (ok == false)
     {
       final_reached = false;
       ok = true;
       zero = false;
       max = positions+1;

       // Initiating the string s to "BBBBBB...":
       for (j=0; j <= positions+3; j++) s [j] = 66;
       s [positions+4] = 0;

       std::cin.getline (s, positions+3);

       if ((s [0] == 48) && (s [2] == 66))   // If the chain represents 0
       {
         ok = true;
         zero = true;
       }
       else    // Usual case
       {
         for (i=0; i<=positions; i++)
           {
           if (s [i] == 0) final_reached = true;
           if (s [i] == 0) max = i;
           if (final_reached == false) if (s [i] < 48) ok = false;
           if (final_reached == false) if (s [i] > 57) ok = false;
           }
         if (s [positions+1] == 0) final_reached = true;
         if (final_reached == false) ok = false;
         if (s [0] == 0) ok = false;
         if (s [0] == 48) ok = false; // not to begin number with 0

         for (i = 0; i < positions + 2; i++)
           if (s [i] == 0) length = i;
         if (length > positions + 1) ok = false;
       }
     }

   // initialize:

   for (i = 0; i <= positions; i++) cipher [i] = 0;

   if (zero == false)
   {
      for (i = 0; i < max; i++) cipher [i] = s [max-i-1] - 48;

      // Determine maxpos:
         ok = false;
         i = positions+1;
         while (ok == false)
           {
             i--;
             if (cipher [i] != 0) ok = true;
           }
         maxpos = i;
   }
   else
   {
      maxpos = 0;
   }


   // The number entered is considered positive:
      positive = true;
}


int main ()
      // **********************************
      //      Main function
      // **********************************
{
  big_number test;    // creates a variable of type big_number

  test.get_number ();
  test.write ();
  test.put_to_zero ();
  test.write ();

return 0;

}