// ________________________________________
// 02.cpp
// ----------------------------------------

// .... What's new? .......................
// "put_to_one"
//  bool equal (big_number a, big_number b)  true if a = b
//  bool bigger (big_number a, big_number b) true if a > b
//  overflow
// ........................................

#include <stdio.h>
#include <iostream.h>

// #include <iostream>  // for MS Visual C++

#define numbertype unsigned short int // Adapt to the number of positions
#define basis 10                      // Adapt to the numberin system
                                      // (decimal, hex, etc...)
#define small unsigned short int      // small must be great enough to
                                      // contain the basis
#define sufficient 200                // chane length for input

const numbertype positions = 7;
bool overflow = false;                // a global variable


// - - - Auxiliary functions - - - - - - - - - - - - - - - - - - - - - - - -


numbertype maxim (numbertype a, numbertype b);
numbertype maxim (numbertype a, numbertype b)
{
   numbertype max;

   if (a > b) max = a; else max = b;
   return (max);
}


// - - - Class big_number  - - - - - - - - - - - - - - - - - - - - - - - - -


class big_number
      // ----------------------------------
      // Definition of class big_number
      // ----------------------------------
{
    small cipher [positions+1];
    numbertype  maxpos;
    bool positive;
  public:
    void get_number ();
    void write ();
    void put_to_zero ();
    void put_to_one ();
    bool equal (big_number a, big_number b);
    bool bigger (big_number a, big_number b);
};


void big_number::get_number ()
      // ----------------------------------
      // Number input from keyboard
      // ----------------------------------
{
   char s [sufficient];
   bool ok;
   bool final_reached;
   bool zero;              // the chain represents 0
   numbertype i, j, max;
   numbertype length;

   ok = false;

   while (ok == false)
     {
       final_reached = false;
       ok = true;
       zero = false;
       max = positions+1;

       // Initiating the string s to "BBBBBB...":
       for (j=0; j <= positions+3; j++) s [j] = 66;
       s [positions+4] = 0;

       std::cin.getline (s, positions+3);

       if ((s [0] == 48) && (s [2] == 66))   // If the chain represents 0
       {
         ok = true;
         zero = true;
       }
       else    // Usual case
       {
         for (i=0; i<=positions; i++)
           {
           if (s [i] == 0) final_reached = true;
           if (s [i] == 0) max = i;
           if (final_reached == false) if (s [i] < 48) ok = false;
           if (final_reached == false) if (s [i] > 57) ok = false;
           }
         if (s [positions+1] == 0) final_reached = true;
         if (final_reached == false) ok = false;
         if (s [0] == 0) ok = false;
         if (s [0] == 48) ok = false; // not to begin number with 0

         for (i = 0; i < positions + 2; i++)
           if (s [i] == 0) length = i;
         if (length > positions + 1) ok = false;
       }
     }

   // initialize:

   for (i = 0; i <= positions; i++) cipher [i] = 0;

   if (zero == false)
   {
      for (i = 0; i < max; i++) cipher [i] = s [max-i-1] - 48;

      // Determine maxpos:
         ok = false;
         i = positions+1;
         while (ok == false)
           {
             i--;
             if (cipher [i] != 0) ok = true;
           }
         maxpos = i;
   }
   else
   {
      maxpos = 0;
   }

   // The number entered is considered positive:
      positive = true;
}


void big_number::write ()
      // ----------------------------------
      // Public accessor function
      // writes the big_number to screen
      // ----------------------------------
{
    if (overflow == false)
    {
      numbertype poscounter;
      if (positive == true) std::cout <<  "+"; else std::cout << "-";
      for (poscounter = positions; poscounter > 0; poscounter--)
        std::cout  << cipher [poscounter];
        std::cout  << cipher [0];  // write the last one

      std::cout <<  "   ";            // Control to be eliminated later
      std::cout << maxpos << "\n\n";  // -------

      std::cout << "\n";
    }
    else  std::cout  << "Overflow Error!";
}


void big_number::put_to_zero ()
      // ----------------------------------
      // Public accessor function
      // puts the big_number to 0
      // ----------------------------------
{
    numbertype poscounter;

    for (poscounter = positions; poscounter > 0; poscounter--)
      cipher [poscounter] = 0;
      cipher [poscounter] = 0;  // the last one (position 0)
    maxpos = 0;
    positive = true;
}


void big_number::put_to_one ()
      // ----------------------------------
      // Public accessor function
      // puts the big_number to 1
      // ----------------------------------
{
  put_to_zero ();
  cipher [0] = 1;
}


bool big_number::equal (big_number a, big_number b)
      // ----------------------------------
      // Gives true if the numbers are equal
      // ----------------------------------
{
  numbertype i;
  bool identic;
  identic = true;

  if (a.maxpos != b.maxpos) identic = false;
  for (i=0; i<=positions; i++)
    {
      if (a.cipher [i] != b.cipher [i]) identic = false;
  std::cout  <<  i  <<  "  "  << a.cipher [i] << "  " << b.cipher [i] << "\n";
    }
  std::cout  <<  "---\n";

  return (identic);
}


bool big_number::bigger (big_number a, big_number b)
      // ----------------------------------
      // Gives true if    a > b
      // ----------------------------------
{
  numbertype k;
  bool is_bigger;
  bool enough;

  k = maxim (a.maxpos, b.maxpos);
  enough = false;
  is_bigger = false;

  while (enough == false)
    {
      if (a.cipher [k] < b.cipher [k]) enough = true;
      if (a.cipher [k] > b.cipher [k])
        {
          is_bigger = true;
          enough = true;
        }
      if (k == 0) enough = true;
      k--;
    }

  return (is_bigger);
}


// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -


int main ()
      // **********************************
      //      Main function
      // **********************************
{

  big_number test;    // creates a variable of type big_number
  big_number test2;   // creates a variable of type big_number

  test.get_number ();
  test.write ();
  test2.get_number ();
  test2.write ();

  bool qwerty;
  qwerty = test.equal (test, test2);

  if (qwerty == true)    std::cout  <<  "Yes...\n";
  if (qwerty != true)    std::cout  <<  "No...\n";

return 0;

}