// ________________________________________
// 05.cpp
// ----------------------------------------

// .... What's new? .......................
// subt subtraction
// div division
// ........................................

#include <stdio.h>           // for Borland Compiler
#include <iostream.h>        // for Borland Compiler

// #include <iostream>       // for MS Visual C++

#define numbertype unsigned short int // Adapt to the number of positions
#define basis 10                      // Adapt to the numbering system
                                      // (decimal, hex, etc...)
#define small unsigned short int      // small must be great enough to
                                      // contain the basis
#define medium unsigned short int     // medium must be great enough to
                                      // contain the square of the basis
#define sufficient 200                // chane length for input

const numbertype positions = 4;       // a constant
bool overflow = false;                // a global variable


// - - - Auxiliary functions:  - - - - - - - - - - - - - - - - - - - - - - -


numbertype maxim (numbertype a, numbertype b);
void print (int number);

numbertype maxim (numbertype a, numbertype b)
{
   numbertype max;

   if (a > b) max = a; else max = b;
   return (max);
}


void print (int number)
      // ----------------------------------
      // Number output on screen (for test purposes)
      // ----------------------------------
{
   std::cout  << number << " ";
}

// - - - Class big_number: - - - - - - - - - - - - - - - - - - - - - - - - -


class big_number
      // ----------------------------------
      // Definition of class big_number
      // ----------------------------------
{
    small cipher [positions+1];
    numbertype  maxpos;
    bool positive;
  public:
    void get_number ();
    void write ();
    void put_to_zero ();
    void put_to_one ();
    bool equal (big_number a, big_number b);
    bool bigger (big_number a, big_number b);
    void sum (big_number a, big_number b);
    void subt (big_number a, big_number b);
    void mult (big_number a, big_number b);
    void div (big_number a, big_number b, big_number &rest);
    void shift_left ();
};


// - - - big_number functions: - - - - - - - - - - - - - - - - - - - - - - -


void big_number::get_number ()
      // ----------------------------------
      // Number input from keyboard
      // ----------------------------------
{
   char s [sufficient];
   bool ok;
   bool final_reached;
   bool zero;              // the chain represents 0
   numbertype i, j, max;
   numbertype length;

   ok = false;

   while (ok == false)
       {
         final_reached = false;
         ok = true;
         zero = false;
         max = positions+1;

         // Initiating the string s to "BBBBBB...":
        for (j=0; j <= positions+3; j++) s [j] = 66;
        s [positions+4] = 0;

        std::cin.getline (s, positions+3);

         if ((s [0] == 48) && (s [2] == 66))   // If the chain represents 0
        {
           ok = true;
           zero = true;
         }
         else    // Usual case
         {
           for (i=0; i<=positions; i++)
             {
             if (s [i] == 0) final_reached = true;
             if (s [i] == 0) max = i;
             if (final_reached == false) if (s [i] < 48) ok = false;
             if (final_reached == false) if (s [i] > 57) ok = false;
             }
           if (s [positions+1] == 0) final_reached = true;
           if (final_reached == false) ok = false;
           if (s [0] == 0) ok = false;
           if (s [0] == 48) ok = false; // not to begin number with 0

           for (i = 0; i < positions + 2; i++)
             if (s [i] == 0) length = i;
           if (length > positions + 1) ok = false;
         }
       if (ok == false) std::cout << "Error" << "\n";
     }

   // initialize:

   for (i = 0; i <= positions; i++) cipher [i] = 0;

   if (zero == false)
   {
      for (i = 0; i < max; i++) cipher [i] = s [max-i-1] - 48;

      // Determine maxpos:
         ok = false;
         i = positions+1;
         while (ok == false)
           {
             i--;
             if (cipher [i] != 0) ok = true;
           }
         maxpos = i;
   }
   else
   {
      maxpos = 0;
   }

   // The number entered is considered positive:
      positive = true;
}


void big_number::write ()
      // ----------------------------------
      // Public accessor function
      // writes the big_number to screen
      // ----------------------------------
{
    if (overflow == false)
    {
      numbertype poscounter;
      if (positive == true) std::cout <<  "+"; else std::cout << "-";
      for (poscounter = positions; poscounter > 0; poscounter--)
        std::cout  << cipher [poscounter];
        std::cout  << cipher [0];  // write the last one

      std::cout <<  "   ";            // Control to be eliminated later
      std::cout << maxpos; //    << "\n\n";  // -------

      std::cout << "\n";
    }
    else  std::cout  << "Overflow Error!";
}


void big_number::put_to_zero ()
      // ----------------------------------
      // Public accessor function
      // puts the big_number to 0
      // ----------------------------------
{
    numbertype poscounter;

    for (poscounter = positions; poscounter > 0; poscounter--)
      cipher [poscounter] = 0;
      cipher [poscounter] = 0;  // the last one (position 0)
    maxpos = 0;
    positive = true;
}


void big_number::put_to_one ()
      // ----------------------------------
      // Public accessor function
      // puts the big_number to 1
      // ----------------------------------
{
  put_to_zero ();
  cipher [0] = 1;
}


bool big_number::equal (big_number a, big_number b)
      // ----------------------------------
      // Gives true if the numbers are equal
      // ----------------------------------
{
  numbertype i;
  bool identic;
  identic = true;

  if (a.maxpos != b.maxpos) identic = false;
  for (i=0; i<=positions; i++)
    {
      if (a.cipher [i] != b.cipher [i]) identic = false;
    }

  return (identic);
}


bool big_number::bigger (big_number a, big_number b)
      // ----------------------------------
      // Gives true if    a > b
      // ----------------------------------
{
  numbertype k;
  bool is_bigger;
  bool enough;

  k = maxim (a.maxpos, b.maxpos);
  enough = false;
  is_bigger = false;

  while (enough == false)
    {
      if (a.cipher [k] < b.cipher [k]) enough = true;
      if (a.cipher [k] > b.cipher [k])
        {
          is_bigger = true;
          enough = true;
        }
      if (k == 0) enough = true;
      k--;
    }
  return (is_bigger);
}


void big_number::sum (big_number a, big_number b)
      // ----------------------------------
      // The sum of a and b
      // ----------------------------------
{
   numbertype i, n;
   medium s, keep;

   if (overflow != true)
   {
     put_to_zero ();                                 // sum = 0
     n = maxim (a.maxpos, b.maxpos);
     keep = 0;
     for (i = 0; i <= n; i++)
       {
         s = a.cipher [i] + b.cipher [i] + keep;
         keep = s / basis;         // in Pascal it would be: s DIV basis
         cipher [i] = s % basis;   // in Pascal it would be: s MOD basis
       }

     if (keep != 0) if (n == positions) overflow = true;
     if (keep != 0) if (n < positions)
        {
          n++;
          cipher [n] = keep;
        }
     maxpos = n;
   }
}


void big_number::subt (big_number a, big_number b)
      // ----------------------------------
      // The difference of a and b
      // Only works if a >= b
      // ----------------------------------
{
   numbertype i, last;
   medium d, keep;
   bool found = false;

   if (overflow != true)
   {
     put_to_zero ();                                 // subt = 0
     last = maxim (a.maxpos, b.maxpos);
     keep = 0;
     for (i = 0; i <= last; i++)
       {
         if (a.cipher [i] >= (b.cipher [i] + keep) )
           {
             d = a.cipher [i] - b.cipher [i] - keep;
             keep = 0;
           }
         else
           {
             d = basis + a.cipher [i] - b.cipher [i] - keep;
             keep = 1;
           }
         cipher [i] = d;
       }
     if (keep != 0) overflow = true;

     // to determinate maxpos:
     for (i = positions; i > 0; i--)
         {
           if (found == false) if (cipher [i] != 0)
             {
               maxpos = i;
               found = true;
             }
         }
     if (found == false) maxpos = 0;

   }
}



void big_number::shift_left ()
      // ----------------------------------
      // Multiplication with the basis
      // ----------------------------------
{
   numbertype i;
   bool is_zero;

   if (overflow != true)
   {
     if (maxpos == positions)
       overflow = true;
     else
     {
       if ((maxpos == 0) && (cipher [0] == 0))        // && is AND
              is_zero = true;
       else   is_zero = false;

       for (i = maxpos + 1; i > 0; i--) cipher [i] = cipher [i - 1];

       cipher [0] = 0;
       if (is_zero == false) maxpos++;
     }
   }
}



void big_number::mult (big_number a, big_number b)
      // ----------------------------------
      // The product of a and b
      // ----------------------------------
{
   numbertype i, j, k;
   medium keep, p;
   bool exit = false;
   bool found = false;

   big_number partial, result, auxiliar;

   if (overflow != true)
   {
     put_to_zero ();                                 // sum = 0
     partial.put_to_zero ();
     result.put_to_zero ();
     auxiliar.put_to_zero ();

     // If one of the factors is zero, the product is zero:
     if (equal (partial, a) == true) exit = true;
     if (equal (partial, b) == true) exit = true;

     // If both factors different from zero:
     if (exit == false)
     {
         for (j = 0; j <= b.maxpos; j++)
         {
           partial.put_to_zero ();
           partial.maxpos = positions;  // Even if the first positions may be 0
           keep = 0;
           for (i = 0; i <= positions; i++)
             {
               k = i + j;
               p = a.cipher [i] * b.cipher [j] + keep;
               if (k <= positions) partial.cipher [k] = p % basis;
               keep = p / basis;
               if (k > positions) if (p > 0) overflow = true;
             }
           if (keep != 0) if (k <= positions)
             {
               partial.cipher [k+1] = keep;
             }

           auxiliar = result;

           result.sum (auxiliar, partial);
         }                                 //  for (j = 0; j <= positions; j++)

       // to copy the ciphers
       for (i = 0; i <= positions; i++)
         {
           cipher [i] = result.cipher [i];
         }

       // to determinate maxpos:
       for (i = positions; i > 0; i--)
         {
           if (found == false) if (cipher [i] != 0)
             {
               maxpos = i;
               found = true;
             }
         }
       if (found == false) maxpos = 0;
     }                                                    // if (exit == false)
   }                                                   // if (overflow != true)
}



void big_number::div (big_number a, big_number b, big_number &rest)
      // ----------------------------------
      // The quotient of a and b, a / b
      //   rest is passed by reference and so
      //   its global value can be changed
      // ----------------------------------
{
   numbertype i, pos;
   big_number aux, z;
   bool enough = false, exit = false, found = false;
   small times;


   if (overflow != true)
   {
     z.put_to_zero ();     // to compare with zero

     if (b.equal (b, z) == true)
        {
          overflow = true;
          exit = true;
        }

     if (b.bigger (b, a) == true)
        {
           put_to_zero ();  // puts quotient to zero
           rest = a;
           exit = true;
        }

     if (exit == false)
        {
          put_to_zero ();
          aux.put_to_zero ();
          rest.put_to_zero ();

          pos = positions;
          aux.cipher [0] = a.cipher [pos];

          while (enough == false)
            {
              times = 0;
              while (   (aux.equal (aux, b) == true)
                     || (aux.bigger (aux, b) == true))       // || means OR
                {
                  times++;
                  aux.subt (aux, b);
                }
              cipher [pos] = times;
              if (pos > 0) pos--;
                           else enough = true;
              if (enough == false)
                {
                  aux.shift_left ();
                  aux.cipher [0] = a.cipher [pos];
                }
            }                                        // while (enough == false)
          rest = aux;

          // to determinate maxpos of quotient:
          for (i = positions; i > 0; i--)
            {
              if (found == false) if (cipher [i] != 0)
                {
                  maxpos = i;
                  found = true;
                }
            }
          if (found == false) maxpos = 0;

          // to determinate maxpos of rest:
          found = false;
          for (i = positions; i > 0; i--)
            {
              if (found == false) if (rest.cipher [i] != 0)
                {
                  rest.maxpos = i;
                  found = true;
                }
            }
          if (found == false) rest.maxpos = 0;

        }                                                 // if (exit == false)
   }                                                   // if (overflow != true)
}


// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -


int main ()
      // **********************************
      //      Main function
      // **********************************
{

  big_number a;    // creates a variable of type big_number
  big_number b;
  big_number c;
  big_number r;

  a.get_number ();
  b.get_number ();

  c.div (a, b, r);

  c.write ();
  r.write ();




//  a.get_number ();
//  a.write ();
//  a.shift_left ();
//  a.write ();

return 0;

}